*************************************************************************************
*														*
*	Display routines V1.00. This is an include file for invader1000.x68		*
*														*
*************************************************************************************
*
* some image constants

invader_x		EQU	80+image_x		* invader's x co-ordinate
invader_y		EQU	150			* invader's y co-ordinate

inv_miss_x		EQU	84+image_x		* invader's missile x co-ordinate
inv_miss_y		EQU	160			* invader's missile y co-ordinate

play_miss_x		EQU	84+image_x		* player's missile x co-ordinate
play_miss_y		EQU	126			* player's missile y co-ordinate

player_x		EQU	84+image_x		* player's x co-ordinate
player_y		EQU	354			* player's y co-ordinate

saucer_x		EQU	player_x		* saucer's x co-ordinate, must = player_x
saucer_y		EQU	114			* saucer's y co-ordinate

explosion_x1	EQU	72+image_x		* explosion x1
explosion_x2	EQU	95+image_x		* explosion x2
explosion_y		EQU	136			* explosion y

level_digit_x	EQU	198+image_x		* level 1 digit x
level_digit_y	EQU	42			* level 1 digit y
level_digit_oset	EQU	20			* level digit y offset

player_base_y	EQU	372

col_offset		EQU	34			* x offset between columns
row_offset		EQU	38			* y offset between rows

*************************************************************************************
*
* light the segments for the lives remaining

display_lives
	MOVE.w	lives(a3),d4		* get the lives remaining count
	MOVE.w	#player_base_y,d2		* set the base segment y co-ordinate
	MOVEQ		#0,d5				* clear the x offset
	MOVEQ		#2,d7				* set the display count
display_lives_loop
	MOVE.l	segment_green(a3),d1	* set the on colour
	SUBQ.w	#1,d4				* decrement the lives count
	BPL.s		lives_on			* if not out of lives skip the off mask

	AND.l		#colour_off,d1		* else mask the off colour
lives_on
	MOVEQ		#81,d0			* set the fill colour for draw/erase
	TRAP		#15

	LEA		player_base_x,a1		* point to the base station x co-ordinates
	MOVEQ		#2,d6				* set the segment count
base_segment_loop
	MOVE.w	(a1)+,d1			* get the segment x co-ordinate
	ADD.w		d5,d1				* add the digit x offset

	MOVEQ		#89,d0			* flood fill the segment
	TRAP		#15

	DBF		d6,base_segment_loop	* loop if more segments

	ADD.w		#col_offset,d5		* add the column offset
	DBF		d7,display_lives_loop	* loop if more bases

	RTS

player_base_x
	dc.w	72+image_x				* missile station x co-ordinate 1
	dc.w	84+image_x				* missile station x co-ordinate 2
	dc.w	90+image_x				* missile station x co-ordinate 3


*************************************************************************************
*
* display the sound status

speaker_x	EQU	18+image_x			* speaker x co-ordinate
speaker_y	EQU	154				* speaker y co-ordinate
not_on_x	EQU	18+image_x			* not on x co-ordinate
not_on_y	EQU	146				* not on y co-ordinate

display_sound
	MOVE.l	segment_green(a3),d1	* set the on colour
	MOVEQ		#81,d0			* set the fill colour for draw/erase
	TRAP		#15

	MOVE.w	#speaker_x,d1		* set the fill x co-ordinate
	MOVE.w	#speaker_y,d2		* set the fill y co-ordinate
	MOVEQ		#89,d0			* flood fill the segment
	TRAP		#15

	MOVE.l	segment_red(a3),d1	* set the on colour
	TST.w		play_sound(a3)		* test the sound status
	BEQ.s		sound_off			* if sound off skip the colour mask

	AND.l		#colour_off,d1		* else mask the off colour
sound_off
	MOVEQ		#81,d0			* set the fill colour for draw/erase
	TRAP		#15

	MOVE.w	#not_on_x,d1		* set the fill x co-ordinate
	MOVE.w	#not_on_y,d2		* set the fill y co-ordinate
	MOVEQ		#89,d0			* flood fill the segment
	TRAP		#15

	RTS


*************************************************************************************
*
* display the saucer

display_saucer
	MOVE.w	#saucer_y,d2		* get the saucer segment y co-ordinate
	MOVE.l	segment_red(a3),d3	* set the on colour
	MOVE.w	saucer_position(a3),d4	* get the saucer position
	BRA.s		display_item		* go display the saucer


*************************************************************************************
*
* display the player

display_player
	MOVE.w	#player_y,d2		* get the player segment y co-ordinate
	MOVE.l	segment_green(a3),d3	* set the on colour
	MOVE.w	player_position(a3),d4	* get the player position

	MOVE.l	explosions(a3),d5		* get the explosion segment pattern
	AND.l		#$20202000,d5		* mask the player positions
	BEQ.s		show_player			* if not the player exploding go display the
							* player

	MOVEQ		#0,d4				* else no player to display
show_player
*##	BRA.s		display_item		* go display the player


*************************************************************************************
*
* display an item. the saucer or the player

display_item
	MOVEQ		#0,d5				* clear the x offset
	MOVEQ		#2,d7				* set the item positions count
display_item_loop
	MOVE.l	d3,d1				* set the on colour
	SUBQ.w	#1,d4				* decrement the item's position
	BEQ.s		item_on			* if this position is on skip the off mask

	AND.l		#colour_off,d1		* else mask the off colour
item_on
	MOVEQ		#81,d0			* set the fill colour for draw/erase
	TRAP		#15

	MOVE.w	#player_x,d1		* get the segment x co-ordinate
	ADD.w		d5,d1				* add the item x offset

	MOVEQ		#89,d0			* flood fill the segment
	TRAP		#15

	ADD.w		#col_offset,d5		* add the column offset
	DBF		d7,display_item_loop	* loop if more positions

	RTS


*************************************************************************************
*
* display the level. this fills the small 1, 2 and 3 at the upper right of the display

display_level
	MOVE.w	level(a3),d4		* get the game level
	MOVE.w	#level_digit_y,d2		* set the digit y co-ordinate
	MOVEQ		#2,d7				* set the level positions count
display_level_loop
	MOVE.l	segment_green(a3),d1	* set the on colour
	SUBQ.w	#1,d4				* decrement the player position
	BEQ.s		level_on			* if this position is on skip the off mask

	AND.l		#colour_off,d1		* else mask the off colour
level_on
	MOVEQ		#81,d0			* set the fill colour for draw/erase
	TRAP		#15

	MOVE.w	#level_digit_x,d1		* set the digit x co-ordinate
	MOVEQ		#89,d0			* flood fill the segment
	TRAP		#15

	ADD.w		#level_digit_oset,d2	* add the next digit y offset
	DBF		d7,display_level_loop	* loop if more positions

	RTS


*************************************************************************************
*
* display the player's missile

display_missile
	MOVE.l	player_missile(a3),d4	* get the player missile segment position
	MOVE.w	#play_miss_x,d3		* set the missile segment x
	MOVE.w	#play_miss_y,-(sp)	* set the missile segment y
	MOVE.l	segment_red(a3),-(sp)	* set the on colour
	BRA.s		display_objects		* go display the objects


*************************************************************************************
*
* display the invaders

display_invaders
	MOVE.l	invader_1(a3),d4		* get invader_1's segment pattern
	OR.l		invader_2(a3),d4		* OR with invader_2's segment pattern
	ADD.l		d4,d4				* do the initial shift for the BCS check
	MOVE.w	#invader_x,d3		* set the invaders segment x
	MOVE.w	#invader_y,-(sp)		* set the invaders segment y
	MOVE.l	segment_green(a3),-(sp)	* set the on colour
*##	BRA.s		display_objects		* go display the objects


*************************************************************************************
*
* display the objects. the segment pattern is in d4.l, the origin x co-ordinate is in
* d3.w, the origin y co-ordinate is in 4(sp).w and the segment colour is in (sp).l

display_objects
	MOVEQ		#0,d5				* clear the column x offset
	MOVEQ		#2,d6				* set the object columns count
object_x_loop
	MOVE.w	4(sp),d2			* get the object segment y
	MOVEQ		#5,d7				* set the object rows count
object_y_loop
	MOVE.l	(sp),d1			* set the on colour
	ADD.l		d4,d4				* shift the object position
	BCS.s		object_on			* if this position is on skip the off mask

	AND.l		#colour_off,d1		* else mask the off colour
object_on
	MOVEQ		#81,d0			* set the fill colour for draw/erase
	TRAP		#15

	MOVE.w	d3,d1				* copy the segment x
	ADD.w		d5,d1				* add the column offset
	MOVEQ		#89,d0			* flood fill the segment
	TRAP		#15

	ADD.w		#row_offset,d2		* add the row offset
	DBF		d7,object_y_loop		* loop if more rows

	LSL.l		#2,d4				* shift the object position
	ADD.w		#col_offset,d5		* add one column to the column x offset
	DBF		d6,object_x_loop		* loop if more columns

	ADDQ.w	#6,sp				* dump the column x offset
	RTS


*************************************************************************************
*
* display the invader's fire. this routine must be called before display_player as it
* overwrites the player segments

display_fire
	MOVE.l	invader_missile+invader_1(a3),d4
							* get invader_1's missile segment pattern
	OR.l		invader_missile+invader_2(a3),d4
							* OR with invader_2's missile segment pattern
	ADD.l		d4,d4				* do the initial shift for the BCS check
	MOVE.w	#inv_miss_x,d3		* set the invader's missile segment x
	MOVE.w	#inv_miss_y,-(sp)		* set the invader's missile segment y
	MOVE.l	segment_green(a3),-(sp)	* set the on colour
	BRA.s		display_objects		* go display the objects


*************************************************************************************
*
* display the explosions. saucer, invader or player

display_explosions
	MOVE.l	explosions(a3),d4		* get the explosions segment pattern

	MOVE.w	#row_offset,d3		* set the row y offset
	MOVEQ		#0,d5				* clear the column x offset
	MOVEQ		#2,d6				* set the explosion columns count
explosion_x_loop
	MOVE.w	#explosion_y,d2		* set the explosion segment y
	MOVEQ		#6,d7				* set the explosion rows count
explosion_y_loop
	MOVE.l	segment_red(a3),d1	* set the on colour
	ADD.l		d4,d4				* shift the explosion position
	BCS.s		explosion_on		* if this position is on skip the off mask

	AND.l		#colour_off,d1		* else mask the off colour
explosion_on
	MOVEQ		#81,d0			* set the fill colour for draw/erase
	TRAP		#15

	MOVE.w	#explosion_x1,d1		* set the first explosion segment x
	ADD.w		d5,d1				* add the column offset
	MOVEQ		#89,d0			* flood fill the segment
	TRAP		#15

	ADD.w		#explosion_x2-explosion_x1,d1
							* set the second explosion segment x
*##	MOVEQ		#89,d0			* flood fill the segment
	TRAP		#15

	ADD.w		d3,d2				* add the row y offset
	DBF		d7,explosion_y_loop	* loop if more rows

	ADD.l		d4,d4				* shift the explosion position
	ADD.w		#col_offset,d5		* add one column to the column x offset
	DBF		d6,explosion_x_loop	* loop if more columns

	RTS


*************************************************************************************
*
* extract the next digit value from the score. this is easy on the 68k as the DIVU
* instruction returns both the result of a divide and the remainder. in this case
* the remainder is what we are interested in and is saved to the digit, the divide
* result is just passed back

next_digit
	DIVU.w	d0,d1				* divide for next digit
	SWAP		d1				* remainder into low word
	MOVE.b	(a1,d1.w),(a0)+		* save the digit segment pattern
	CLR.w		d1				* clear remainder
	SWAP 		d1				* return the remaining score
	RTS


*************************************************************************************
*
* display the score

display_score
	MOVEQ		#0,d1				* clear the longword
	MOVE.w	score(a3),d1		* get the score
	LEA		score_disp(a3),a0		* point to the score display pattern
	LEA		digit_segs(pc),a1		* point to the segment patterns
	MOVEQ		#10,d0			* set the digit divisor
	BSR.s		next_digit			* do digit
	BSR.s		next_digit			* do digit
	BSR.s		next_digit			* do digit

	LEA		score_disp(a3),a0		* point to the score display pattern
	MOVEQ		#0,d5				* clear the x offset
	BSR.s		display_digit		* display a digit
	SUB.w		#col_offset,d5		* add the column x offset
	BSR.s		display_digit		* display a digit
	SUB.w		#col_offset,d5		* add the column x offset
*##	BRA.s		display_digit		* display a digit


*************************************************************************************
*
* display a digit

display_digit
	LEA		segments(pc),a1		* point to the segment co-ordinates
	MOVE.b	(a0)+,d4			* get the segment patern
	MOVEQ		#6,d7				* set the segment count
segment_loop
	MOVE.l	segment_green(a3),d1	* set the on colour
	ADD.b		d4,d4				* shift the segment pattern
	BCC.s		segment_off			* if the segment is off go mask the colour

	CMPI.w	#30,missiles(a3)		* compare 30 with remaining missiles
	BGT.s		no_flash_score		* if > 30 skip the score flash

	MOVEQ		#8,d0				* set count mask
	AND.w		counter(a3),d0		* mask the count
	AND.w		playmode(a3),d0		* AND with the playing flag
	BEQ.s		no_flash_score		* if set use the on colour

segment_off
	AND.l		#colour_off,d1		* else mask the off colour
no_flash_score
	MOVEQ		#81,d0			* set the fill colour for draw/erase
	TRAP		#15

	MOVE.w	(a1)+,d1			* get the segment x co-ordinate
	MOVE.w	(a1)+,d2			* get the segment y co-ordinate
	ADD.w		d5,d1				* add the digit x offset

	MOVEQ		#89,d0			* flood fill the segment
	TRAP		#15

	DBF		d7,segment_loop		* if more segments to do loop

	RTS


*************************************************************************************
*
* score digit tables

* segments in each byte are gfedcba.

digit_segs
	dc.b	%01111110				* 0
	dc.b	%00001100				* 1
	dc.b	%10110110				* 2
	dc.b	%10011110				* 3
	dc.b	%11001100				* 4
	dc.b	%11011010				* 5
	dc.b	%11111010				* 6
	dc.b	%00001110				* 7
	dc.b	%11111110				* 8
	dc.b	%11011110				* 9

* segment x,y co-ordinates for the 1s digit

segments
	dc.w	153+image_x,64			* segment g x,y
	dc.w	146+image_x,58			* segment f x,y
	dc.w	146+image_x,72			* segment e x,y
	dc.w	153+image_x,78			* segment d x,y
	dc.w	160+image_x,72			* segment c x,y
	dc.w	160+image_x,58			* segment b x,y
	dc.w	153+image_x,50			* segment a x,y


*************************************************************************************
