*************************************************************************************
*														*
*	Keyboard routines V1.00. This is an include file for invader1000.x68		*
*														*
*************************************************************************************
*
* handle the keys

do_keys
	MOVEQ		#$53,d1			* [][][][S] key
	MOVEQ		#0,d2				* clear longword
	MOVE.w	s_key(a3),d2		* get the last [S] key status

	MOVEQ		#19,d0			* check for keypress
	TRAP		#15

	MOVE.w	d1,d0				* copy the result, each byte is $00 if key
							* up, $FF if key down
	EOR.w		d2,d1				* compare with last key(s) state, each byte
							* is now $FF if a key has changed or $00 if
							* a key has not changed
	MOVE.w	d0,d2				* save this result as last
	AND.w		d2,d1				* make each byte $FF if key just pressed or
							* $00 if key not just pressed, set Zb status
	BEQ.s		no_toggle_sound		* if no key press skip sound toggle

	EORI.w	#-1,play_sound(a3)	* toggle the sound flag
no_toggle_sound
	MOVE.w	d2,s_key(a3)		* save the last [S] key status
go_do_keys
	TST.w		playmode(a3)		* test the playing flag
	BEQ.s		not_playing_keys		* if not playing go test the not playing keys

	MOVE.l	#'MMZC',d1			* [M] fire, [Z] left and [C] right keys
	MOVE.b	#19,d0			* check for keypress
	TRAP		#15

	MOVEQ		#2,d0				* set centre position
	SUB.b		d1,d0				* add 1 if [C] pressed
	ROL.w		#8,d1				* shift the [Z] byte
	ADD.b		d1,d0				* subtract 1 if [Z] pressed
	MOVE.w	d0,player_position(a3)	* save the player position

	SWAP		d1				* shift [MS] keys to the low word
	TST.w		d1				* test the [M] key
	BPL.s		exit_do_keys		* if not set just exit

	MOVE.w	d1,fire(a3)			* else set the fire flag
exit_do_keys
	RTS

not_playing_keys
	MOVE.l	#$20333231,d1		* [SPACE] start, [3], [2] and [1] set level
	MOVE.b	#19,d0			* check for keypress
	TRAP		#15

	TST.l		d1				* test the returned [SPACE] flag
	BMI		start_game			* if [SPACE] set go start the game

	LSR.l		#6,d1				* shift [3], [2] and [1] flags
	MOVE.w	d1,d0				* copy the shifted flags
	LSR.w		#7,d0				* shift [3], [2] and [1] flags again
	AND.w		#$0006,d1			* mask bits for [2] and [1] flags
	AND.w		#$0008,d0			* mask a bit for [3] flag
	OR.w		d1,d0				* OR the [3] and [2], [1] flags

							* 33333333 22222222 11111111 original
							* ......33 33333322 22222211 first LSR
							*          ........ .....XX. first mask
							*          .....333 33333222 second LSR
							*          ........ ....X... second mask
							*          ........ ....321. result

	MOVE.w	valid_levels(pc,d0.w),d0
							* get the level from the 123 keys table
	BEQ.s		exit_not_playing_keys	* if not a valid level just exit

	MOVE.w	d0,level(a3)		* else set the level
exit_not_playing_keys
	RTS

valid_levels
	dc.w	0,1,2,0,3,0,0,0,0			* the only valid level offsets are 2, 4 and 8


*************************************************************************************

