*************************************************************************************
*														*
*	Sound routines V1.00. This is an include file for invader1000.x68			*
*														*
*	load the sounds, play an indexed sample. Uses the DirextX sound play and	*
*	requires EASy68K 3.7.10 beta or later.							*
*														*
*************************************************************************************
*
* initialise the sounds routine

sound_init
	LEA		draw_sound(pc),a1		* point to the game draw sound file name
	MOVEQ		#11,d1			* index 11
	BSR.s		load_sound			* load the sound into directx memory

	LEA		win_sound(pc),a1		* point to the game win sound file name
	MOVEQ		#10,d1			* index 10
	BSR.s		load_sound			* load the sound into directx memory

	LEA		ammo_sound(pc),a1		* point to the low ammo sound file name
	MOVEQ		#9,d1				* index 9
	BSR.s		load_sound			* load the sound into directx memory

	LEA		life_sound(pc),a1		* point to the extra life sound file name
	MOVEQ		#8,d1				* index 8
	BSR.s		load_sound			* load the sound into directx memory

	LEA		sauc_sound(pc),a1		* point to the saucer sound file name
	MOVEQ		#7,d1				* index 7
	BSR.s		load_sound			* load the sound into directx memory

	LEA		fire_sound(pc),a1		* point to the player fire sound file name
	MOVEQ		#6,d1				* index 6
	BSR.s		load_sound			* load the sound into directx memory

	LEA		hiti_sound(pc),a1		* point to the hit invader sound file name
	MOVEQ		#5,d1				* index 5
	BSR.s		load_sound			* load the sound into directx memory

	LEA		hits_sound(pc),a1		* point to the hit saucer sound file name
	MOVEQ		#4,d1				* index 4
	BSR.s		load_sound			* load the sound into directx memory

	LEA		die4_sound(pc),a1		* point to the hit player sound file name
	MOVEQ		#3,d1				* index 2
	BSR.s		load_sound			* load the sound into directx memory

	LEA		die3_sound(pc),a1		* point to the hit player sound file name
	MOVEQ		#2,d1				* index 2
	BSR.s		load_sound			* load the sound into directx memory

	LEA		die2_sound(pc),a1		* point to the hit player sound file name
	MOVEQ		#1,d1				* index 2
	BSR.s		load_sound			* load the sound into directx memory

	LEA		die1_sound(pc),a1		* point to the hit player sound file name
	MOVEQ		#0,d1				* index 2


*************************************************************************************
*
* load the sound into directx memory

load_sound
	MOVEQ		#74,d0			* load the sound into directx memory
	TRAP		#15
	RTS


*************************************************************************************
*
* play a sound sample

play_sample
	TST.w		play_sound(a3)		* test the sound flag
	BEQ.s		exit_play_sample		* if the sound is off just exit

	MOVEQ		#75,d0			* play a sound from directx memory
	TRAP		#15

exit_play_sample
	RTS


*************************************************************************************
*
* sound file names

draw_sound
	dc.b	'draw.wav',$00			* game draw sound

win_sound
	dc.b	'win.wav',$00			* game win sound

ammo_sound
	dc.b	'ammo.wav',$00			* low ammo sound

life_sound
	dc.b	'life.wav',$00			* extra life sound

sauc_sound
	dc.b	'saucer.wav',$00			* saucer sound

fire_sound
	dc.b	'fire.wav',$00			* player fire sound

hiti_sound
	dc.b	'hitinvader.wav',$00		* hit invader sound

hits_sound
	dc.b	'hitsaucer.wav',$00		* hit saucer sound

die1_sound
	dc.b	'die1.wav',$00			* player hit sound

die2_sound
	dc.b	'die2.wav',$00			* player hit sound

die3_sound
	dc.b	'die3.wav',$00			* player hit sound

die4_sound
	dc.b	'die4.wav',$00			* player hit sound

	ds.w	0					* ensure even


*************************************************************************************

